searchData={"items":[{"type":"behaviour","doc":"Used for creating strategies.","title":"Assent.Strategy","ref":"Assent.Strategy.html"},{"type":"behaviour","doc":"Set up `my_strategy.ex` the following way:\n\n    defmodule MyStrategy do\n      @behaviour Assent.Strategy\n\n      alias Assent.Strategy, as: Helpers\n\n      def authorize_url(config) do\n        # Generate redirect URL\n\n        {:ok, %{url: url, ...}}\n      end\n\n      def callback(config, params) do\n        # Fetch user data\n\n        user = Helpers.normalize_userinfo(userinfo)\n\n        {:ok, %{user: user, ...}}\n      end\n    end","title":"Usage - Assent.Strategy","ref":"Assent.Strategy.html#module-usage"},{"type":"callback","doc":"","title":"Assent.Strategy.authorize_url/1","ref":"Assent.Strategy.html#c:authorize_url/1"},{"type":"callback","doc":"","title":"Assent.Strategy.callback/2","ref":"Assent.Strategy.html#c:callback/2"},{"type":"function","doc":"Decode a JSON string.","title":"Assent.Strategy.decode_json/2","ref":"Assent.Strategy.html#decode_json/2"},{"type":"function","doc":"- `:json_library` - The JSON library to use, see\n  `Assent.json_library/1`","title":"Options - Assent.Strategy.decode_json/2","ref":"Assent.Strategy.html#decode_json/2-options"},{"type":"function","doc":"","title":"Assent.Strategy.decode_response/2","ref":"Assent.Strategy.html#decode_response/2"},{"type":"function","doc":"Makes a HTTP request.\n\nSee `Assent.HTTPAdapter.request/5`.","title":"Assent.Strategy.http_request/5","ref":"Assent.Strategy.html#http_request/5"},{"type":"function","doc":"Normalize API user request response into standard claims.\n\nBased on https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1","title":"Assent.Strategy.normalize_userinfo/2","ref":"Assent.Strategy.html#normalize_userinfo/2"},{"type":"function","doc":"Recursively prunes map for nil values.","title":"Assent.Strategy.prune/1","ref":"Assent.Strategy.html#prune/1"},{"type":"function","doc":"","title":"Assent.Strategy.request/5","ref":"Assent.Strategy.html#request/5"},{"type":"function","doc":"Signs a JSON Web Token.\n\nSee `Assent.JWTAdapter.sign/3` for options.","title":"Assent.Strategy.sign_jwt/4","ref":"Assent.Strategy.html#sign_jwt/4"},{"type":"function","doc":"Generates a URL.","title":"Assent.Strategy.to_url/3","ref":"Assent.Strategy.html#to_url/3"},{"type":"function","doc":"Verifies a JSON Web Token.\n\nSee `Assent.JWTAdapter.verify/3` for options.","title":"Assent.Strategy.verify_jwt/3","ref":"Assent.Strategy.html#verify_jwt/3"},{"type":"module","doc":"Apple Sign In OAuth 2.0 strategy.\n\nYou'll need to collect the 10-char long Team ID, the Services ID, the 10-char\nKey ID and download the private key from the portal. Save the private key to\nan accessible folder, or alternatively set `:private_key` with the content of\nthe private key.","title":"Assent.Strategy.Apple","ref":"Assent.Strategy.Apple.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_SERVICES_ID\",\n      team_id: \"REPLACE_WITH_TEAM_ID\",\n      private_key_id: \"REPLACE_WITH_PRIVATE_KEY_ID\",\n      private_key_path: \"/path/to/private_key.p8\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]","title":"Usage - Assent.Strategy.Apple","ref":"Assent.Strategy.Apple.html#module-usage"},{"type":"module","doc":"You can use the JS SDK instead of handling it through `auhorize_url/2`. All you\nhave to do is to set up you HTML page with the following way:\n\n     \n       \n           \n           \n           \n           \n       \n       \n            \n            \n       \n     \n\nYou can get the state by generating the session params using the\n`authorize_url/2`:\n\n    {:ok, %{session_params: session_params}} = Assent.Strategy.Apple.authorize_url(config)\n\nUse the `session_params[:state]` value for `[STATE]`. The callback phase\nwould be identical to how it's explained in the [README](README.md).\n\nSee https://developer.apple.com/documentation/signinwithapplejs/configuring_your_webpage_for_sign_in_with_apple\nfor more.","title":"With JS SDK - Assent.Strategy.Apple","ref":"Assent.Strategy.Apple.html#module-with-js-sdk"},{"type":"module","doc":"Auth0 OAuth 2.0 strategy.","title":"Assent.Strategy.Auth0","ref":"Assent.Strategy.Auth0.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      domain: \"REPLACE_WITH_DOMAIN\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Auth0","ref":"Assent.Strategy.Auth0.html#module-usage"},{"type":"module","doc":"Azure Active Directory OpenID Connect strategy.","title":"Assent.Strategy.AzureAD","ref":"Assent.Strategy.AzureAD.html"},{"type":"module","doc":"- `:tenant_id` - The Azure tenant ID, optional, defaults to `common`\n\nSee `Assent.Strategy.OIDC` for more.","title":"Configuration - Assent.Strategy.AzureAD","ref":"Assent.Strategy.AzureAD.html#module-configuration"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nA tenant id can be set to limit scope of users who can get access (defaults\nto \"common\"):\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      tenant_id: \"REPLACE_WITH_TENANT_ID\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]","title":"Usage - Assent.Strategy.AzureAD","ref":"Assent.Strategy.AzureAD.html#module-usage"},{"type":"module","doc":"Login to Azure, and set up a new application:\nhttps://docs.microsoft.com/en-us/azure/active-directory/develop/quickstart-register-app\n\n* The callback URL should be added to \"Redirect URI\" for the application.\n* `client_id` is the \"Application ID\".","title":"Setting up Azure AD - Assent.Strategy.AzureAD","ref":"Assent.Strategy.AzureAD.html#module-setting-up-azure-ad"},{"type":"module","doc":"Basecamp OAuth 2.0 strategy.\n\nIn the normalized user response a `basecamp_accounts` field is included that\ncan be used to limit access to users belonging to a particular account.\n\nThe Basecamp user endpoint does not provide data on email verification, email\nis considered unverified.","title":"Assent.Strategy.Basecamp","ref":"Assent.Strategy.Basecamp.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Basecamp","ref":"Assent.Strategy.Basecamp.html#module-usage"},{"type":"module","doc":"Bitbucket Cloud OAuth 2.0 strategy.","title":"Assent.Strategy.Bitbucket","ref":"Assent.Strategy.Bitbucket.html"},{"type":"module","doc":"- `:user_emails_url` - The API path or URL to fetch e-mails from, defaults to `/user/emails`\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Configuration - Assent.Strategy.Bitbucket","ref":"Assent.Strategy.Bitbucket.html#module-configuration"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CONSUMER_KEY\",\n      client_secret: \"REPLACE_WITH_CONSUMER_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]","title":"Usage - Assent.Strategy.Bitbucket","ref":"Assent.Strategy.Bitbucket.html#module-usage"},{"type":"module","doc":"DigitalOcean OAuth 2.0 strategy.","title":"Assent.Strategy.DigitalOcean","ref":"Assent.Strategy.DigitalOcean.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.DigitalOcean","ref":"Assent.Strategy.DigitalOcean.html#module-usage"},{"type":"module","doc":"Discord OAuth 2.0 strategy.","title":"Assent.Strategy.Discord","ref":"Assent.Strategy.Discord.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Discord","ref":"Assent.Strategy.Discord.html#module-usage"},{"type":"module","doc":"Facebook OAuth 2.0 strategy.\n\nThe Facebook user endpoint does not provide data on email verification, email\nis considered unverified. More here:\nhttps://developers.facebook.com/docs/facebook-login/multiple-providers#postfb1","title":"Assent.Strategy.Facebook","ref":"Assent.Strategy.Facebook.html"},{"type":"module","doc":"- `:user_url_request_fields` - The fields for the resource, defaults to\n  `email,name,first_name,last_name,middle_name,link`\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Configuration - Assent.Strategy.Facebook","ref":"Assent.Strategy.Facebook.html#module-configuration"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Facebook","ref":"Assent.Strategy.Facebook.html#module-usage"},{"type":"module","doc":"You can use the JS SDK instead of handling it through `auhorize_url/2`. All\nyou have to do is to set up you HTML page with the following way:\n\n     \n     \n     \n     \n\n     \n      function checkLoginState() {\n        FB.getLoginStatus(function(response) {\n          let signedRequest = response.authResponse.signedRequest\n          let encodedPayload = atob(signedRequest.split('.')[1])\n          let payload = JSON.parse(encodedPayload)\n\n          window.location.href = '<%= @redirect_uri %>?&code=' + encodeURI(payload.code)\n        });\n      }\n\n      window.fbAsyncInit = function() {\n        FB.init({\n          appId   : '[CLIENT_ID]',\n          cookie  : true, // required for server to pick up session\n          version : 'v6.0',\n          xfbml   : true\n        });\n      };\n     \n      \n\nIn the above, the signed request is decoded and the authorization code is\nfetched from it. The `@redirect_uri` is the callback URL.\n\nYou have to use an empty `redirect_uri` for the callback:\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Keyword.put(:redirect_uri, \"\")\n      |> Assent.Strategy.Facebook.callback(params)","title":"With JS SDK - Assent.Strategy.Facebook","ref":"Assent.Strategy.Facebook.html#module-with-js-sdk"},{"type":"module","doc":"Github OAuth 2.0 strategy.","title":"Assent.Strategy.Github","ref":"Assent.Strategy.Github.html"},{"type":"module","doc":"- `:user_emails_url` - The API path or URL to fetch e-mails from, defaults to `/user/emails`\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Configuration - Assent.Strategy.Github","ref":"Assent.Strategy.Github.html#module-configuration"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Github","ref":"Assent.Strategy.Github.html#module-usage"},{"type":"module","doc":"Gitlab OAuth 2.0 strategy.","title":"Assent.Strategy.Gitlab","ref":"Assent.Strategy.Gitlab.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Gitlab","ref":"Assent.Strategy.Gitlab.html#module-usage"},{"type":"module","doc":"Google OAuth 2.0 strategy.\n\nIn the normalized user response a `google_hd` (\"Hosted Domain\") field is\nincluded in user parameters and can be used to limit access to users\nbelonging to a particular hosted domain.","title":"Assent.Strategy.Google","ref":"Assent.Strategy.Google.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nTo get the refresh token, it's necessary to pass `access_type: \"offline\"` in\nthe authorization request:\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      authorization_params: [\n        access_type: \"offline\",\n        scope: \"https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/userinfo.profile\"\n      ]\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Google","ref":"Assent.Strategy.Google.html#module-usage"},{"type":"module","doc":"Instagram OAuth 2.0 strategy.\n\nThe Instagram user object does not provide data on email verification, email\nis considered unverified.","title":"Assent.Strategy.Instagram","ref":"Assent.Strategy.Instagram.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Instagram","ref":"Assent.Strategy.Instagram.html#module-usage"},{"type":"module","doc":"LINE Login OpenID Connect Strategy.","title":"Assent.Strategy.LINE","ref":"Assent.Strategy.LINE.html"},{"type":"module","doc":"config = [\n    client_id: \"REPLACE_WITH_CLIENT_ID\",\n    client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n    redirect_uri: \"http://localhost:4000/auth/callback\"\n  ]\n\nSee `Assent.Strategy.OIDC` for more.","title":"Usage - Assent.Strategy.LINE","ref":"Assent.Strategy.LINE.html#module-usage"},{"type":"module","doc":"Sign In with LinkedIn V2 OpenID Connect Strategy.\n\nYou'll need the `Sign In with LinkedIn v2` product enabled in your app. See the\n[LinkedIn integration guide](https://learn.microsoft.com/en-us/linkedin/consumer/integrations/self-serve/sign-in-with-linkedin-v2)\nfor more.","title":"Assent.Strategy.Linkedin","ref":"Assent.Strategy.Linkedin.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OIDC` for more.","title":"Usage - Assent.Strategy.Linkedin","ref":"Assent.Strategy.Linkedin.html#module-usage"},{"type":"module","doc":"OAuth 1.0a strategy.\n\n`authorize_url/1` returns a map with a `:session_params` and `:url` key. The\n`:session_params` key carries a `:oauth_token_secret` value for the request.","title":"Assent.Strategy.OAuth","ref":"Assent.Strategy.OAuth.html"},{"type":"module","doc":"- `:consumer_key` - The OAuth consumer key, required\n  - `:base_url` - The base URL of the OAuth server, required\n  - `:signature_method` -  The signature method, optional, defaults to\n    `:hmac_sha1`. The value may be one of the following:\n\n    - `:hmac_sha1` - Generates signature with HMAC-SHA1\n    - `:rsa_sha1` - Generates signature with RSA-SHA1\n    - `:plaintext` - Doesn't generate signature\n  - `:consumer_secret` - The OAuth consumer secret, required if\n    `:signature_method` is either `:hmac_sha1` or `:plaintext`\n  - `:private_key_path` - The path for the private key, required if\n    `:signature_method` is `:rsa_sha1` and `:private_key` hasn't been set\n  - `:private_key` - The private key content that can be defined instead of\n    `:private_key_path`, required if `:signature_method` is `:rsa_sha1` and\n    `:private_key_path` hasn't been set","title":"Configuration - Assent.Strategy.OAuth","ref":"Assent.Strategy.OAuth.html#module-configuration"},{"type":"module","doc":"config = [\n      consumer_key: \"REPLACE_WITH_CONSUMER_KEY\",\n      consumer_secret: \"REPLACE_WITH_CONSUMER_SECRET\",\n      base_url: \"https://auth.example.com\",\n      authorization_params: [scope: \"user:read user:write\"],\n      user_url: \"https://example.com/api/user\"\n    ]\n\n    {:ok, {url: url, session_params: session_params}} =\n      config\n      |> Keyword.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> OAuth.authorize_url()\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Keyword.put(:session_params, session_params)\n      |> OAuth.callback(params)","title":"Usage - Assent.Strategy.OAuth","ref":"Assent.Strategy.OAuth.html#module-usage"},{"type":"function","doc":"Generate authorization URL for request phase.","title":"Assent.Strategy.OAuth.authorize_url/1","ref":"Assent.Strategy.OAuth.html#authorize_url/1"},{"type":"function","doc":"- `:redirect_uri` - The URI that the server redirects the user to after\n    authentication, required\n  - `:request_token_url` - The path or URL to fetch the token from, optional,\n    defaults to `/oauth/request_token`\n  - `:authorize_url` - The path or URL for the OAuth server to redirect users\n    to, defaults to `/oauth/authenticate`\n  - `:authorization_params` - The authorization parameters, defaults to `[]`","title":"Options - Assent.Strategy.OAuth.authorize_url/1","ref":"Assent.Strategy.OAuth.html#authorize_url/1-options"},{"type":"function","doc":"Callback phase for generating access token and fetch user data.","title":"Assent.Strategy.OAuth.callback/3","ref":"Assent.Strategy.OAuth.html#callback/3"},{"type":"function","doc":"- `:access_token_url` - The path or URL to fetch the access token from,\n    optional, defaults to `/oauth/access_token`\n  - `:user_url` - The path or URL to fetch user data, required\n  - `:session_params` - The session parameters that was returned from\n    `authorize_url/1`, optional","title":"Options - Assent.Strategy.OAuth.callback/3","ref":"Assent.Strategy.OAuth.html#callback/3-options"},{"type":"type","doc":"","title":"Assent.Strategy.OAuth.on_authorize_url/0","ref":"Assent.Strategy.OAuth.html#t:on_authorize_url/0"},{"type":"type","doc":"","title":"Assent.Strategy.OAuth.on_callback/0","ref":"Assent.Strategy.OAuth.html#t:on_callback/0"},{"type":"function","doc":"Performs a signed HTTP request to the API using the oauth token.","title":"Assent.Strategy.OAuth.request/6","ref":"Assent.Strategy.OAuth.html#request/6"},{"type":"type","doc":"","title":"Assent.Strategy.OAuth.session_params/0","ref":"Assent.Strategy.OAuth.html#t:session_params/0"},{"type":"behaviour","doc":"OAuth 1.0 strategy base.","title":"Assent.Strategy.OAuth.Base","ref":"Assent.Strategy.OAuth.Base.html"},{"type":"behaviour","doc":"defmodule MyApp.MyOAuthStratey do\n      use Assent.Strategy.OAuth\n\n      @impl true\n      def default_config(_config) do\n        [\n          base_url: \"https://api.example.com\",\n          authorize_url: \"/authorization/new\",\n          access_token_url: \"/authorization/access_token\"\n          request_token_url: \"/authorization/request_token\",\n          user_url: \"/authorization.json\",\n          authorization_params: [scope: \"default\"]\n        ]\n      end\n\n      @impl true\n      def normalize(_config, user) do\n        {:ok,\n          # Conformed to https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1\n          %{\n            \"sub\"   => user[\"id\"],\n            \"name\"  => user[\"name\"],\n            \"email\" => user[\"email\"]\n          # },\n          # # Provider specific data not part of the standard claims spec\n          # %{\n          #  \"https://example.com/bio\" => user[\"bio\"]\n          }\n        }\n      end\n    end","title":"Usage - Assent.Strategy.OAuth.Base","ref":"Assent.Strategy.OAuth.Base.html#module-usage"},{"type":"function","doc":"","title":"Assent.Strategy.OAuth.Base.authorize_url/2","ref":"Assent.Strategy.OAuth.Base.html#authorize_url/2"},{"type":"function","doc":"","title":"Assent.Strategy.OAuth.Base.callback/3","ref":"Assent.Strategy.OAuth.Base.html#callback/3"},{"type":"callback","doc":"","title":"Assent.Strategy.OAuth.Base.default_config/1","ref":"Assent.Strategy.OAuth.Base.html#c:default_config/1"},{"type":"callback","doc":"","title":"Assent.Strategy.OAuth.Base.fetch_user/2","ref":"Assent.Strategy.OAuth.Base.html#c:fetch_user/2"},{"type":"callback","doc":"","title":"Assent.Strategy.OAuth.Base.normalize/2","ref":"Assent.Strategy.OAuth.Base.html#c:normalize/2"},{"type":"module","doc":"OAuth 2.0 strategy.\n\nThis strategy only supports the Authorization Code flow per\n[RFC 6749](https://tools.ietf.org/html/rfc6749#section-1.3.1).\n\n`authorize_url/1` returns a map with a `:url` and `:session_params` key. The\n`:session_params` should be stored and passed back into `callback/3` as part\nof config when the user returns. The `:session_params` carries a `:state`\nvalue for the request [to prevent\nCSRF](https://tools.ietf.org/html/rfc6749#section-4.1.1). If `:code_verifier`\nis set to true, the `:session_params` will also carry PKCE [code verification\nparameters](https://datatracker.ietf.org/doc/html/rfc7636#section-4).\n\nThis library also supports JWT tokens for client authentication as per\n[RFC 7523](https://tools.ietf.org/html/rfc7523).","title":"Assent.Strategy.OAuth2","ref":"Assent.Strategy.OAuth2.html"},{"type":"module","doc":"- `:client_id` - The OAuth2 client id, required\n  - `:base_url` - The base URL of the OAuth2 server, required\n  - `:auth_method` - The authentication strategy used, optional. If not set,\n    no authentication will be used during the access token request (e.g.\n    public clients). The value may be one of the following:\n\n    - `:client_secret_basic` - Authenticate with basic authorization header\n    - `:client_secret_post` - Authenticate with post params\n    - `:client_secret_jwt` - Authenticate with JWT using `:client_secret` as\n      secret\n    - `:private_key_jwt` - Authenticate with JWT using `:private_key_path` or\n      `:private_key` as secret\n  - `:client_secret` - The OAuth2 client secret, required if `:auth_method`\n    is `:client_secret_basic`, `:client_secret_post`, or `:client_secret_jwt`\n  - `:private_key_id` - The private key ID, required if `:auth_method` is\n    `:private_key_jwt`\n  - `:private_key_path` - The path for the private key, required if\n    `:auth_method` is `:private_key_jwt` and `:private_key` hasn't been set\n  - `:private_key` - The private key content that can be defined instead of\n    `:private_key_path`, required if `:auth_method` is `:private_key_jwt` and\n    `:private_key_path` hasn't been set\n  - `:jwt_algorithm` - The algorithm to use for JWT signing, optional,\n    defaults to `HS256` for `:client_secret_jwt` and `RS256` for\n    `:private_key_jwt`\n  - `:state` - A boolean or a string with the value of the state, optional,\n    defaults to `true`. When set to `true` a random 32 byte long url safe\n    string is generated. When set to `false` state will not be verified.\n  - `:code_verifier` - Boolean to generate and use a random 128 byte long\n    url safe code verifier for PKCE flow, optional, defaults to `false`. When\n    set to `true` the session params will contain `:code_verifier`,\n    `:code_challenge`, and `:code_challenge_method` params.","title":"Configuration - Assent.Strategy.OAuth2","ref":"Assent.Strategy.OAuth2.html#module-configuration"},{"type":"module","doc":"config =\n      [\n        client_id: \"REPLACE_WITH_CLIENT_ID\",\n        client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n        auth_method: :client_secret_post,\n        base_url: \"https://auth.example.com\",\n        authorization_params: [scope: \"user:read user:write\"],\n        user_url: \"https://example.com/api/user\"\n      ]\n\n    {:ok, %{url: url, session_params: session_params}} =\n      config\n      |> Keyword.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> Assent.Strategy.OAuth2.authorize_url()\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Keyword.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> Keyword.put(:session_params, session_params)\n      |> Assent.Strategy.OAuth2.callback(params)","title":"Usage - Assent.Strategy.OAuth2","ref":"Assent.Strategy.OAuth2.html#module-usage"},{"type":"function","doc":"Generate authorization URL for request phase.","title":"Assent.Strategy.OAuth2.authorize_url/1","ref":"Assent.Strategy.OAuth2.html#authorize_url/1"},{"type":"function","doc":"- `:redirect_uri` - The URI that the server redirects the user to after\n    authentication, required\n  - `:authorize_url` - The path or URL for the OAuth2 server to redirect\n    users to, defaults to `/oauth/authorize`\n  - `:authorization_params` - The authorization parameters, defaults to `[]`","title":"Options - Assent.Strategy.OAuth2.authorize_url/1","ref":"Assent.Strategy.OAuth2.html#authorize_url/1-options"},{"type":"function","doc":"Callback phase for generating access token with authorization code and fetch\nuser data. Returns a map with access token in `:token` and user data in\n`:user`.","title":"Assent.Strategy.OAuth2.callback/3","ref":"Assent.Strategy.OAuth2.html#callback/3"},{"type":"function","doc":"- `:token_url` - The path or URL to fetch the token from, optional,\n    defaults to `/oauth/token`\n  - `:user_url` - The path or URL to fetch user data, required\n  - `:session_params` - The session parameters that was returned from\n    `authorize_url/1`, optional","title":"Options - Assent.Strategy.OAuth2.callback/3","ref":"Assent.Strategy.OAuth2.html#callback/3-options"},{"type":"function","doc":"Fetch user data with the access token.\n\nUses `request/6` to fetch the user data.","title":"Assent.Strategy.OAuth2.fetch_user/4","ref":"Assent.Strategy.OAuth2.html#fetch_user/4"},{"type":"function","doc":"Grants an access token.","title":"Assent.Strategy.OAuth2.grant_access_token/3","ref":"Assent.Strategy.OAuth2.html#grant_access_token/3"},{"type":"type","doc":"","title":"Assent.Strategy.OAuth2.on_authorize_url/0","ref":"Assent.Strategy.OAuth2.html#t:on_authorize_url/0"},{"type":"type","doc":"","title":"Assent.Strategy.OAuth2.on_callback/0","ref":"Assent.Strategy.OAuth2.html#t:on_callback/0"},{"type":"function","doc":"Refreshes the access token.","title":"Assent.Strategy.OAuth2.refresh_access_token/3","ref":"Assent.Strategy.OAuth2.html#refresh_access_token/3"},{"type":"function","doc":"Performs a HTTP request to the API using the access token.","title":"Assent.Strategy.OAuth2.request/6","ref":"Assent.Strategy.OAuth2.html#request/6"},{"type":"type","doc":"","title":"Assent.Strategy.OAuth2.session_params/0","ref":"Assent.Strategy.OAuth2.html#t:session_params/0"},{"type":"behaviour","doc":"OAuth 2.0 strategy base.","title":"Assent.Strategy.OAuth2.Base","ref":"Assent.Strategy.OAuth2.Base.html"},{"type":"behaviour","doc":"defmodule MyApp.MyOAuth2Strategy do\n      use Assent.Strategy.OAuth2.Base\n\n      def default_config(_config) do\n        [\n          base_url: \"https://api.example.com\",\n          user_url: \"/authorization.json\"\n        ]\n      end\n\n      @impl true\n      def normalize(_config, user) do\n        {:ok,\n          # Conformed to https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1\n          %{\n            \"sub\"   => user[\"id\"],\n            \"name\"  => user[\"name\"],\n            \"email\" => user[\"email\"]\n          # },\n          # # Provider specific data not part of the standard claims spec\n          # %{\n          #  \"https://example.com/bio\" => user[\"bio\"]\n          }\n        }\n      end\n    end","title":"Usage - Assent.Strategy.OAuth2.Base","ref":"Assent.Strategy.OAuth2.Base.html#module-usage"},{"type":"function","doc":"","title":"Assent.Strategy.OAuth2.Base.authorize_url/2","ref":"Assent.Strategy.OAuth2.Base.html#authorize_url/2"},{"type":"function","doc":"","title":"Assent.Strategy.OAuth2.Base.callback/3","ref":"Assent.Strategy.OAuth2.Base.html#callback/3"},{"type":"callback","doc":"","title":"Assent.Strategy.OAuth2.Base.default_config/1","ref":"Assent.Strategy.OAuth2.Base.html#c:default_config/1"},{"type":"callback","doc":"","title":"Assent.Strategy.OAuth2.Base.fetch_user/2","ref":"Assent.Strategy.OAuth2.Base.html#c:fetch_user/2"},{"type":"callback","doc":"","title":"Assent.Strategy.OAuth2.Base.normalize/2","ref":"Assent.Strategy.OAuth2.Base.html#c:normalize/2"},{"type":"module","doc":"OpenID Connect strategy.\n\nThis is built upon the `Assent.Strategy.OAuth2` strategy with added OpenID\nConnect capabilities.","title":"Assent.Strategy.OIDC","ref":"Assent.Strategy.OIDC.html"},{"type":"module","doc":"- `:client_id` - The client id, required\n  - `:base_url` - The OIDC issuer, required\n  - `:openid_configuration_uri` - The URI for OpenID Provider, optional,\n    defaults to `/.well-known/openid-configuration`\n  - `:client_authentication_method` - The Client Authentication method to\n    use, optional, defaults to `client_secret_basic`.  The value may be one\n    of the following:\n\n    - `none` - No client authentication, used with public clients\n    - `client_secret_basic` - Authenticate with basic authorization header\n    - `client_secret_post` - Authenticate with post params\n    - `client_secret_jwt` - Authenticate with JWT using `:client_secret` as\n      secret\n    - `private_key_jwt` - Authenticate with JWT using `:private_key_path` or\n      `:private_key` as secret\n  - `:client_secret` - The client secret, required if\n    `:client_authentication_method` is `client_secret_basic`,\n    `:client_secret_post`, or `:client_secret_jwt`\n  - `:openid_configuration` - The OpenID configuration, optional, the\n    configuration will be fetched from `:openid_configuration_uri` if this is\n    not defined\n  - `:id_token_signed_response_alg` - The `id_token_signed_response_alg`\n    parameter sent by the Client during Registration, defaults to `RS256`\n  - `:id_token_ttl_seconds` - The number of seconds from `iat` that an ID\n    Token will be considered valid, optional, defaults to nil\n  - `:nonce` - The nonce to use for authorization request, optional, MUST be\n    session based and unguessable\n  - `:trusted_audiences` - A list of audiences that are trusted, optional.\n\nSee `Assent.Strategy.OAuth2` for more configuration options.","title":"Configuration - Assent.Strategy.OIDC","ref":"Assent.Strategy.OIDC.html#module-configuration"},{"type":"module","doc":"config =  [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      base_url: \"https://server.example.com\",\n      authorization_params: [scope: \"user:read user:write\"]\n    ]\n\n    {:ok, {url: url, session_params: session_params}} =\n      config\n      |> Keyword.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> Assent.Strategy.OIDC.authorize_url()\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Keyword.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> Keyword.put(:session_params, session_params)\n      |> Assent.Strategy.OIDC.callback(params)","title":"Usage - Assent.Strategy.OIDC","ref":"Assent.Strategy.OIDC.html#module-usage"},{"type":"module","doc":"`:nonce` can be set in the provider config. The `:nonce` will be returned in\nthe `:session_params` along with `:state`. You can use this to store the value\nin the current session e.g. a httpOnly session cookie.\n\nA random value generator can look like this:\n\n    16\n    |> :crypto.strong_rand_bytes()\n    |> Base.encode64(padding: false)\n\nPowAssent will dynamically generate one for the session if `:nonce` is set to\n`true`.\n\nSee `Assent.Strategy.OIDC.authorize_url/1` for more.","title":"Nonce - Assent.Strategy.OIDC","ref":"Assent.Strategy.OIDC.html#module-nonce"},{"type":"function","doc":"Generates an authorization URL for request phase.\n\nThe authorization url will be fetched from the OpenID configuration URI.\n\n`openid` will automatically be added to the `:scope` in\n`:authorization_params`, unless `:openid_default_scope` has been set.\n\nAdd `:nonce` to the config to pass it with the authorization request. The\nnonce will be returned in `:session_params`. The nonce MUST be session based\nand unguessable. A cryptographic hash of a cryptographically random value\ncould be stored in a httpOnly session cookie.\n\nSee `Assent.Strategy.OAuth2.authorize_url/1` for more.","title":"Assent.Strategy.OIDC.authorize_url/1","ref":"Assent.Strategy.OIDC.html#authorize_url/1"},{"type":"function","doc":"Callback phase for generating access token and fetch user data.\n\nThe token url will be fetched from the OpenID configuration URI.\n\nIf the returned ID Token is signed with a symmetric key, `:client_secret`\nwill be required and used to verify the ID Token. If it was signed with a\nprivate key, the appropriate public key will be fetched from the `jwks_uri`\nsetting in the OpenID configuration to verify the ID Token.\n\nThe ID Token will be validated per\n[OpenID Connect Core 1.0 rules](https://openid.net/specs/openid-connect-core-1_0.html#IDTokenValidation).\n\nSee `Assent.Strategy.OAuth2.callback/3` for more.","title":"Assent.Strategy.OIDC.callback/3","ref":"Assent.Strategy.OIDC.html#callback/3"},{"type":"function","doc":"Fetches user params from ID token.\n\nThe ID Token is validated, and the claims is returned as the user params.\nUse `fetch_userinfo/2` to fetch the claims from the `userinfo` endpoint.","title":"Assent.Strategy.OIDC.fetch_user/2","ref":"Assent.Strategy.OIDC.html#fetch_user/2"},{"type":"function","doc":"Fetches claims from userinfo endpoint.\n\nThe userinfo will be fetched from the `userinfo_endpoint` OpenID\nconfiguration.\n\nThe returned claims will be validated against the `id_token` verifying that\n`sub` is equal.","title":"Assent.Strategy.OIDC.fetch_userinfo/2","ref":"Assent.Strategy.OIDC.html#fetch_userinfo/2"},{"type":"type","doc":"","title":"Assent.Strategy.OIDC.on_authorize_url/0","ref":"Assent.Strategy.OIDC.html#t:on_authorize_url/0"},{"type":"type","doc":"","title":"Assent.Strategy.OIDC.on_callback/0","ref":"Assent.Strategy.OIDC.html#t:on_callback/0"},{"type":"type","doc":"","title":"Assent.Strategy.OIDC.session_params/0","ref":"Assent.Strategy.OIDC.html#t:session_params/0"},{"type":"function","doc":"Validates the ID token.\n\nThe OpenID configuration will be dynamically fetched if not set in the\nconfig.\n\nThe ID Token will be validated per\n[OpenID Connect Core 1.0 rules](https://openid.net/specs/openid-connect-core-1_0.html#IDTokenValidation).","title":"Assent.Strategy.OIDC.validate_id_token/2","ref":"Assent.Strategy.OIDC.html#validate_id_token/2"},{"type":"behaviour","doc":"OIDC OAuth 2.0 strategy base.","title":"Assent.Strategy.OIDC.Base","ref":"Assent.Strategy.OIDC.Base.html"},{"type":"behaviour","doc":"defmodule MyApp.MyOIDCStrategy do\n      use Assent.Strategy.OIDC.Base\n\n      def default_config(_config) do\n        [\n          base_url: \"https://oidc.example.com\"\n        ]\n      end\n\n      def normalize(_config, user), do: {:ok, user}\n    end","title":"Usage - Assent.Strategy.OIDC.Base","ref":"Assent.Strategy.OIDC.Base.html#module-usage"},{"type":"function","doc":"","title":"Assent.Strategy.OIDC.Base.authorize_url/2","ref":"Assent.Strategy.OIDC.Base.html#authorize_url/2"},{"type":"function","doc":"","title":"Assent.Strategy.OIDC.Base.callback/3","ref":"Assent.Strategy.OIDC.Base.html#callback/3"},{"type":"callback","doc":"","title":"Assent.Strategy.OIDC.Base.default_config/1","ref":"Assent.Strategy.OIDC.Base.html#c:default_config/1"},{"type":"callback","doc":"","title":"Assent.Strategy.OIDC.Base.fetch_user/2","ref":"Assent.Strategy.OIDC.Base.html#c:fetch_user/2"},{"type":"callback","doc":"","title":"Assent.Strategy.OIDC.Base.normalize/2","ref":"Assent.Strategy.OIDC.Base.html#c:normalize/2"},{"type":"module","doc":"Slack OAuth 2.0 OpenID Connect strategy.\n\nThe Slack user endpoint does not provide data on email verification, email is\nconsidered unverified.","title":"Assent.Strategy.Slack","ref":"Assent.Strategy.Slack.html"},{"type":"module","doc":"- `:team_id` - The team id to restrict authorization for, optional, defaults to nil\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Configuration - Assent.Strategy.Slack","ref":"Assent.Strategy.Slack.html#module-configuration"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nBy default, the user can decide what team should be used for authorization.\nIf you want to limit to a specific team, please pass a team id to the\nconfiguration:\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      team_id: \"REPLACE_WITH_TEAM_ID\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nThis value will be not be used if you set a `authorization_params` key.\nInstead you should set `team: TEAM_ID` in the `authorization_params` keyword\nlist.","title":"Usage - Assent.Strategy.Slack","ref":"Assent.Strategy.Slack.html#module-usage"},{"type":"module","doc":"Spotify OAuth 2.0 strategy.","title":"Assent.Strategy.Spotify","ref":"Assent.Strategy.Spotify.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Spotify","ref":"Assent.Strategy.Spotify.html#module-usage"},{"type":"module","doc":"Strava OAuth strategy.\n\nThe athlete endpoint, describing the currently authenticated user, does not\nreturn an email address - [changelog](https://developers.strava.com/docs/changelog/#january-17-2019).","title":"Assent.Strategy.Strava","ref":"Assent.Strategy.Strava.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Strava","ref":"Assent.Strategy.Strava.html#module-usage"},{"type":"module","doc":"Stripe Connect OAuth 2.0 strategy.","title":"Assent.Strategy.Stripe","ref":"Assent.Strategy.Stripe.html"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Usage - Assent.Strategy.Stripe","ref":"Assent.Strategy.Stripe.html#module-usage"},{"type":"module","doc":"This strategy uses Connect Standard by default. To use Connect Express, the\nfollowing config can be used:\n\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      authorize_url: \"https://connect.stripe.com/express/oauth/authorize\"\n      # authorization_params: [\n      #   stripe_user: [business_type: \"company\", email: \"user@example.com\"],\n      #   suggested_capabilities: [\"transfers\"]\n      # ]\n    ]","title":"Connect Express - Assent.Strategy.Stripe","ref":"Assent.Strategy.Stripe.html#module-connect-express"},{"type":"module","doc":"Telegram authorization strategy.\n\nSupports both\n[Telegram Login Widget](https://core.telegram.org/widgets/login),\nand  [Web Mini App](https://core.telegram.org/bots/webapps) authorizations.\n\nNote that using the `authorize_url/1` instead of the Telegram JavaScript\nembed script, will send the end-user to the `:return_to` path with a base64\nurl encoded JSON string in a URL fragment. This means that it can only be\naccessed client-side, so it must be parsed with JavaScript and resubmitted\nas query params:\n\n     \n      // Function to decode base64 without padding\n      function decodeBase64Url(base64Url) {\n        let base64 = base64Url.replace(/-/g, '+').replace(/_/g, '/');\n        switch (base64.length % 4) {\n          case 2: base64 += '=='; break;\n          case 3: base64 += '='; break;\n        }\n        return atob(base64);\n      }\n\n      // Parse the hash fragment\n      const hash = window.location.hash.substr(1);\n      const hashData = hash.split('=')\n\n      if (hashData[0] == \"tgAuthResult\") {\n        const data = JSON.parse(decodeBase64Url(hashData[1]))\n        const params = new URLSearchParams(data);\n\n        // Construct the new URL with query parameters\n        const newUrl = new URL(window.location.href.split('#')[0]);\n        params.forEach((value, key) => {\n          newUrl.searchParams.append(key, value);\n        });\n\n        // Redirect to the new URL\n        window.location.href = newUrl.toString();\n      }\n     \n\nNote that the returned user claims can vary widelty, and are depend on the\nauthorization channel and user settings.","title":"Assent.Strategy.Telegram","ref":"Assent.Strategy.Telegram.html"},{"type":"module","doc":"- `:bot_token` - The telegram bot token, required\n  - `:authorization_channel` - The authorization channel, optional, defaults\n    to `:login_widget`, may be one of `:login_widget` or `:web_mini_app`\n  - `:origin` - The origin URL for `authorize_url/1`, required\n  - `:return_to` - The return URL for `authorize_url/1`, required","title":"Configuration - Assent.Strategy.Telegram","ref":"Assent.Strategy.Telegram.html#module-configuration"},{"type":"module","doc":"","title":"Usage - Assent.Strategy.Telegram","ref":"Assent.Strategy.Telegram.html#module-usage"},{"type":"module","doc":"The JavaScript Widget can be implemented with:\n\n      \n\nConfiguration should have:\n\n    config = [\n      bot_token: \"YOUR_FULL_BOT_TOKEN\"\n    ]\n\nNote that if a user declines to authorize access, you have to handle it\nclient-side with JavaScript.","title":"Login Widget - Assent.Strategy.Telegram","ref":"Assent.Strategy.Telegram.html#module-login-widget"},{"type":"module","doc":"config = [\n      bot_token: \"YOUR_FULL_BOT_TOKEN\",\n      authorization_channel: :web_mini_app\n    ]\n\nFor the Web Mini App authorization, the strategy expects the original\n`initData` query param to be passed in as-is.","title":"Web Mini App - Assent.Strategy.Telegram","ref":"Assent.Strategy.Telegram.html#module-web-mini-app"},{"type":"module","doc":"Twitch OpenID Connect strategy.\n\nSee `Assent.Strategy.OIDC` for more.","title":"Assent.Strategy.Twitch","ref":"Assent.Strategy.Twitch.html"},{"type":"module","doc":"Twitter OAuth strategy.\n\nThe Twitter user endpoint only returns verified email, `email_verified` will\nalways be `true`.","title":"Assent.Strategy.Twitter","ref":"Assent.Strategy.Twitter.html"},{"type":"module","doc":"config = [\n      consumer_key: \"REPLACE_WITH_CONSUMER_KEY\",\n      consumer_secret: \"REPLACE_WITH_CONSUMER_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]\n\nSee `Assent.Strategy.OAuth` for more.","title":"Usage - Assent.Strategy.Twitter","ref":"Assent.Strategy.Twitter.html#module-usage"},{"type":"module","doc":"VK.com OAuth 2.0 strategy.\n\nThe VK token endpoint does not provide data on email verification, email is\nconsidered unverified.","title":"Assent.Strategy.VK","ref":"Assent.Strategy.VK.html"},{"type":"module","doc":"- `:user_url_params` - Parameters to send along with the user fetch request,\n  optional, defaults to `[]`\n\nSee `Assent.Strategy.OAuth2` for more.","title":"Configuration - Assent.Strategy.VK","ref":"Assent.Strategy.VK.html#module-configuration"},{"type":"module","doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      redirect_uri: \"http://localhost:4000/auth/callback\"\n    ]","title":"Usage - Assent.Strategy.VK","ref":"Assent.Strategy.VK.html#module-usage"},{"type":"module","doc":"Zitadel Sign In OIDC strategy.","title":"Assent.Strategy.Zitadel","ref":"Assent.Strategy.Zitadel.html"},{"type":"module","doc":"- `:resource_id` - The resource id, required\n\nSee `Assent.Strategy.OIDC` for more configuration options.","title":"Configuration - Assent.Strategy.Zitadel","ref":"Assent.Strategy.Zitadel.html#module-configuration"},{"type":"module","doc":"config = [\n      base_url: \"REPLACE_WITH_ORGANIZATION_URL\",\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      resource_id: \"REPLACE_WITH_RESOURCE_ID\"\n    ]","title":"Usage - Assent.Strategy.Zitadel","ref":"Assent.Strategy.Zitadel.html#module-usage"},{"type":"behaviour","doc":"HTTP adapter helper module.\n\nYou can configure the which HTTP adapter Assent uses by setting the\nconfiguring:\n\n    http_adapter: Assent.HTTPAdapter.Httpc\n\nDefault options can be set by passing a list of options:\n\n    http_adapter: {Assent.HTTPAdapter.Httpc, [...]}\n\nYou can also set global application config:\n\n    config :assent, :http_adapter, Assent.HTTPAdapter.Httpc","title":"Assent.HTTPAdapter","ref":"Assent.HTTPAdapter.html"},{"type":"behaviour","doc":"defmodule MyApp.MyHTTPAdapter do\n      @behaviour Assent.HTTPAdapter\n\n      @impl true\n      def request(method, url, body, headers, opts) do\n        # ...\n      end\n    end","title":"Usage - Assent.HTTPAdapter","ref":"Assent.HTTPAdapter.html#module-usage"},{"type":"type","doc":"","title":"Assent.HTTPAdapter.body/0","ref":"Assent.HTTPAdapter.html#t:body/0"},{"type":"function","doc":"Decodes request response body.","title":"Assent.HTTPAdapter.decode_response/2","ref":"Assent.HTTPAdapter.html#decode_response/2"},{"type":"function","doc":"- `:json_library` - The JSON library to use, see\n  `Assent.json_library/1`","title":"Options - Assent.HTTPAdapter.decode_response/2","ref":"Assent.HTTPAdapter.html#decode_response/2-options"},{"type":"type","doc":"","title":"Assent.HTTPAdapter.headers/0","ref":"Assent.HTTPAdapter.html#t:headers/0"},{"type":"type","doc":"","title":"Assent.HTTPAdapter.method/0","ref":"Assent.HTTPAdapter.html#t:method/0"},{"type":"function","doc":"Makes a HTTP request.","title":"Assent.HTTPAdapter.request/5","ref":"Assent.HTTPAdapter.html#request/5"},{"type":"function","doc":"- `:http_adapter` - The HTTP adapter to use, defaults to\n  `Assent.HTTPAdapter.Req`.\n- `:json_library` - The JSON library to use, see\n  `Assent.json_library/1`.","title":"Options - Assent.HTTPAdapter.request/5","ref":"Assent.HTTPAdapter.html#request/5-options"},{"type":"callback","doc":"","title":"Assent.HTTPAdapter.request/5","ref":"Assent.HTTPAdapter.html#c:request/5"},{"type":"function","doc":"Sets a user agent header.\n\nThe header value will be `Assent-VERSION` with VERSION being the `:vsn` of\n`:assent` app.","title":"Assent.HTTPAdapter.user_agent_header/0","ref":"Assent.HTTPAdapter.html#user_agent_header/0"},{"type":"module","doc":"HTTP adapter module for making http requests with Finch.\n\nThe Finch adapter must be configured with the supervisor by passing it as an\noption:\n\n    http_adapter: {Assent.HTTPAdapter.Finch, [supervisor: MyFinch]}\n\nSee `Assent.HTTPAdapter` for more.","title":"Assent.HTTPAdapter.Finch","ref":"Assent.HTTPAdapter.Finch.html"},{"type":"module","doc":"Struct used by HTTP adapters to normalize HTTP responses.","title":"Assent.HTTPAdapter.HTTPResponse","ref":"Assent.HTTPAdapter.HTTPResponse.html"},{"type":"function","doc":"","title":"Assent.HTTPAdapter.HTTPResponse.format/1","ref":"Assent.HTTPAdapter.HTTPResponse.html#format/1"},{"type":"type","doc":"","title":"Assent.HTTPAdapter.HTTPResponse.header/0","ref":"Assent.HTTPAdapter.HTTPResponse.html#t:header/0"},{"type":"type","doc":"","title":"Assent.HTTPAdapter.HTTPResponse.t/0","ref":"Assent.HTTPAdapter.HTTPResponse.html#t:t/0"},{"type":"module","doc":"HTTP adapter module for making http requests with `:httpc`.\n\nSSL support will automatically be enabled if the `:certifi` and\n`:ssl_verify_fun` libraries exists in your project. You can also override\nthe `:httpc` options by updating the configuration:\n\n    http_adapter: {Assent.HTTPAdapter.Httpc, [...]}\n\nFor releases please make sure you have included `:inets` in your application:\n\n    extra_applications: [:inets]\n\nSee `Assent.HTTPAdapter` for more.","title":"Assent.HTTPAdapter.Httpc","ref":"Assent.HTTPAdapter.Httpc.html"},{"type":"module","doc":"HTTP adapter module for making http requests with Req.\n\nYou can also override the Req options by updating the configuration:\n\n    http_adapter: {Assent.HTTPAdapter.Req, [...]}\n\nSee `Assent.HTTPAdapter` for more.","title":"Assent.HTTPAdapter.Req","ref":"Assent.HTTPAdapter.Req.html"},{"type":"behaviour","doc":"JWT adapter helper module.\n\nYou can configure the JWT adapter by updating the configuration:\n\n    jwt_adapter: {Assent.JWTAdapter.AssentJWT, [...]}\n\nDefault options can be set by passing a list of options:\n\n    jwt_adapter: {Assent.JWTAdapter.AssentJWT, [...]}\n\nYou can also set global application config:\n\n    config :assent, :jwt_adapter, Assent.JWTAdapter.AssentJWT","title":"Assent.JWTAdapter","ref":"Assent.JWTAdapter.html"},{"type":"behaviour","doc":"defmodule MyApp.MyJWTAdapter do\n      @behaviour Assent.JWTAdapter\n\n      @impl true\n      def sign(claims, alg, secret, opts) do\n        # ...\n      end\n\n      @impl true\n      def verify(token, secret, opts) do\n        # ...\n      end\n    end","title":"Usage - Assent.JWTAdapter","ref":"Assent.JWTAdapter.html#module-usage"},{"type":"function","doc":"Loads a private key from the provided configuration.","title":"Assent.JWTAdapter.load_private_key/1","ref":"Assent.JWTAdapter.html#load_private_key/1"},{"type":"function","doc":"- `:private_key_path` - The path to the private key file, optional.\n- `:private_key` - The private key, required if `:private_key_path` is not set.","title":"Options - Assent.JWTAdapter.load_private_key/1","ref":"Assent.JWTAdapter.html#load_private_key/1-options"},{"type":"function","doc":"Generates a signed JSON Web Token signature.","title":"Assent.JWTAdapter.sign/4","ref":"Assent.JWTAdapter.html#sign/4"},{"type":"function","doc":"- `:json_library` - The JSON library to use, optional, see\n  `Assent.json_library/1`.\n- `:jwt_adapter` - The JWT adapter module to use, optional, defaults to\n  `Assent.JWTAdapter.AssentJWT`","title":"Options - Assent.JWTAdapter.sign/4","ref":"Assent.JWTAdapter.html#sign/4-options"},{"type":"callback","doc":"","title":"Assent.JWTAdapter.sign/4","ref":"Assent.JWTAdapter.html#c:sign/4"},{"type":"function","doc":"Verifies the JSON Web Token signature.","title":"Assent.JWTAdapter.verify/3","ref":"Assent.JWTAdapter.html#verify/3"},{"type":"function","doc":"- `:json_library` - The JSON library to use, optional, see\n  `Assent.json_library/1`.\n- `:jwt_adapter` - The JWT adapter module to use, optional, defaults to\n  `Assent.JWTAdapter.AssentJWT`","title":"Options - Assent.JWTAdapter.verify/3","ref":"Assent.JWTAdapter.html#verify/3-options"},{"type":"callback","doc":"","title":"Assent.JWTAdapter.verify/3","ref":"Assent.JWTAdapter.html#c:verify/3"},{"type":"module","doc":"JWT adapter module for parsing JSON Web Tokens natively.\n\nYou can append options to the configuration:\n\n    jwt_adapter: {Assent.JWTAdapter.AssentJWT, [...]}\n\nSee `Assent.JWTAdapter` for more.","title":"Assent.JWTAdapter.AssentJWT","ref":"Assent.JWTAdapter.AssentJWT.html"},{"type":"module","doc":"JWT adapter module for parsing JSON Web Tokens with JOSE.\n\nYou can append options to the configuration:\n\n    jwt_adapter: {Assent.JWTAdapter.JOSE, [...]}\n\nSee `Assent.JWTAdapter` for more.","title":"Assent.JWTAdapter.JOSE","ref":"Assent.JWTAdapter.JOSE.html"},{"type":"exception","doc":"","title":"Assent.CallbackCSRFError","ref":"Assent.CallbackCSRFError.html"},{"type":"function","doc":"","title":"Assent.CallbackCSRFError.message/1","ref":"Assent.CallbackCSRFError.html#message/1"},{"type":"type","doc":"","title":"Assent.CallbackCSRFError.t/0","ref":"Assent.CallbackCSRFError.html#t:t/0"},{"type":"exception","doc":"","title":"Assent.CallbackError","ref":"Assent.CallbackError.html"},{"type":"exception","doc":"","title":"Assent.Config.MissingConfigError","ref":"Assent.Config.MissingConfigError.html"},{"type":"function","doc":"","title":"Assent.Config.MissingConfigError.message/1","ref":"Assent.Config.MissingConfigError.html#message/1"},{"type":"type","doc":"","title":"Assent.Config.MissingConfigError.t/0","ref":"Assent.Config.MissingConfigError.html#t:t/0"},{"type":"exception","doc":"","title":"Assent.InvalidResponseError","ref":"Assent.InvalidResponseError.html"},{"type":"function","doc":"","title":"Assent.InvalidResponseError.message/1","ref":"Assent.InvalidResponseError.html#message/1"},{"type":"type","doc":"","title":"Assent.InvalidResponseError.t/0","ref":"Assent.InvalidResponseError.html#t:t/0"},{"type":"exception","doc":"","title":"Assent.JWTAdapter.AssentJWT.Error","ref":"Assent.JWTAdapter.AssentJWT.Error.html"},{"type":"exception","doc":"","title":"Assent.MissingConfigError","ref":"Assent.MissingConfigError.html"},{"type":"function","doc":"","title":"Assent.MissingConfigError.message/1","ref":"Assent.MissingConfigError.html#message/1"},{"type":"type","doc":"","title":"Assent.MissingConfigError.t/0","ref":"Assent.MissingConfigError.html#t:t/0"},{"type":"exception","doc":"","title":"Assent.MissingParamError","ref":"Assent.MissingParamError.html"},{"type":"function","doc":"","title":"Assent.MissingParamError.message/1","ref":"Assent.MissingParamError.html#message/1"},{"type":"type","doc":"","title":"Assent.MissingParamError.t/0","ref":"Assent.MissingParamError.html#t:t/0"},{"type":"exception","doc":"","title":"Assent.RequestError","ref":"Assent.RequestError.html"},{"type":"type","doc":"","title":"Assent.RequestError.t/0","ref":"Assent.RequestError.html#t:t/0"},{"type":"exception","doc":"","title":"Assent.ServerUnreachableError","ref":"Assent.ServerUnreachableError.html"},{"type":"function","doc":"","title":"Assent.ServerUnreachableError.message/1","ref":"Assent.ServerUnreachableError.html#message/1"},{"type":"type","doc":"","title":"Assent.ServerUnreachableError.t/0","ref":"Assent.ServerUnreachableError.html#t:t/0"},{"type":"exception","doc":"","title":"Assent.UnexpectedResponseError","ref":"Assent.UnexpectedResponseError.html"},{"type":"function","doc":"","title":"Assent.UnexpectedResponseError.message/1","ref":"Assent.UnexpectedResponseError.html#message/1"},{"type":"type","doc":"","title":"Assent.UnexpectedResponseError.t/0","ref":"Assent.UnexpectedResponseError.html#t:t/0"},{"type":"extras","doc":"# Assent\n\n[![Github CI](https://github.com/pow-auth/assent/workflows/CI/badge.svg)](https://github.com/pow-auth/assent/actions?query=workflow%3ACI)\n[![hexdocs.pm](https://img.shields.io/badge/api-docs-green.svg?style=flat)](https://hexdocs.pm/assent)\n[![hex.pm](https://img.shields.io/hexpm/v/assent.svg?style=flat)](https://hex.pm/packages/assent)\n\nMulti-provider authentication framework.","title":"Assent","ref":"README.html"},{"type":"extras","doc":"* Includes the following base strategies:\n  * OAuth 1.0 - `Assent.Strategy.OAuth`\n  * OAuth 2.0 - `Assent.Strategy.OAuth2`\n  * OpenID Connect - `Assent.Strategy.OIDC`\n* Includes the following provider strategies:\n  * Apple Sign In - `Assent.Strategy.Apple`\n  * Auth0 - `Assent.Strategy.Auth0`\n  * Azure AD - `Assent.Strategy.AzureAD`\n  * Basecamp - `Assent.Strategy.Basecamp`\n  * Bitbucket - `Assent.Strategy.Bitbucket`\n  * DigitalOcean - `Assent.Strategy.DigitalOcean`\n  * Discord - `Assent.Strategy.Discord`\n  * Facebook - `Assent.Strategy.Facebook`\n  * Github - `Assent.Strategy.Github`\n  * Gitlab - `Assent.Strategy.Gitlab`\n  * Google - `Assent.Strategy.Google`\n  * Instagram - `Assent.Strategy.Instagram`\n  * LINE Login - `Assent.Strategy.LINE`\n  * Linkedin - `Assent.Strategy.Linkedin`\n  * Spotify - `Assent.Strategy.Spotify`\n  * Strava - `Assent.Strategy.Strava`\n  * Slack - `Assent.Strategy.Slack`\n  * Stripe Connect - `Assent.Strategy.Stripe`\n  * Telegram - `Assent.Strategy.Telegram`\n  * Twitch - `Assent.Strategy.Twitch`\n  * Twitter - `Assent.Strategy.Twitter`\n  * VK - `Assent.Strategy.VK`\n  * Zitadel - `Assent.Strategy.Zitadel`","title":"Features - Assent","ref":"README.html#features"},{"type":"extras","doc":"Add Assent to your list of dependencies in `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:assent, \"~> 0.2.11\"}\n  ]\nend\n```\n\nRun `mix deps.get` to install it.\n\n#### HTTP client installation\n\nBy default, `Req` is used if you have it in your dependency list. If not, Erlang's `:httpc` will be used instead.\n\nIf you are using `:httpc` you should add the following dependencies to enable SSL validation:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    # Required for SSL validation when using the `:httpc` adapter\n    {:certifi, \"~> 2.4\"},\n    {:ssl_verify_fun, \"~> 1.1\"}\n  ]\nend\n```\n\nYou must also add `:inets` to `:extra_applications` in `mix.exs`:\n\n```elixir\ndef application do\n  [\n    # ...\n    extra_applications: [\n      # ...\n      :inets\n    ]\n  ]\nend\n```\n\nThis is not necessary if you use another HTTP adapter like `Req` or `Finch`.","title":"Installation - Assent","ref":"README.html#installation"},{"type":"extras","doc":"A strategy consists of two phases; request and callback. In the request phase, the user would normally be redirected to the provider for authentication and then returned to initiate the callback phase.","title":"Getting started - Assent","ref":"README.html#getting-started"},{"type":"extras","doc":"```elixir\ndefmodule ProviderAuth do\n  import Plug.Conn\n\n  alias Assent.{Config, Strategy.Github}\n\n  @config [\n    client_id: \"REPLACE_WITH_CLIENT_ID\",\n    client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n    redirect_uri: \"http://localhost:4000/auth/github/callback\"\n  ]\n\n  # http://localhost:4000/auth/github\n  def request(conn) do\n    @config\n    |> Github.authorize_url()\n    |> case do\n      {:ok, %{url: url, session_params: session_params}} ->\n        # Session params (used for OAuth 2.0 and OIDC strategies) will be\n        # retrieved when user returns for the callback phase\n        conn = put_session(conn, :session_params, session_params)\n\n        # Redirect end-user to Github to authorize access to their account\n        conn\n        |> put_resp_header(\"location\", url)\n        |> send_resp(302, \"\")\n\n      {:error, error} ->\n        # Something went wrong generating the request authorization url\n    end\n  end\n\n  # http://localhost:4000/auth/github/callback\n  def callback(conn) do\n    # End-user will return to the callback URL with params attached to the\n    # request. These must be passed on to the strategy. In this example we only\n    # expect GET query params, but the provider could also return the user with\n    # a POST request where the params is in the POST body.\n    %{params: params} = fetch_query_params(conn)\n\n    # The session params (used for OAuth 2.0 and OIDC strategies) stored in the\n    # request phase will be used in the callback phase\n    session_params = get_session(conn, :session_params)\n\n    @config\n    # Session params should be added to the config so the strategy can use them\n    |> Keyword.put(:session_params, session_params)\n    |> Github.callback(params)\n    |> case do\n      {:ok, %{user: user, token: token}} ->\n        # Authorization succesful\n\n      {:error, error} ->\n        # Authorizaiton failed\n    end\n  end\nend\n```","title":"Single provider example - Assent","ref":"README.html#single-provider-example"},{"type":"extras","doc":"This is a generalized flow that's similar to what's used in [PowAssent](https://github.com/danschultzer/pow_assent).\n\n```elixir\nconfig :my_app, :strategies,\n  github: [\n    client_id: \"REPLACE_WITH_CLIENT_ID\",\n    client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n    strategy: Assent.Strategy.Github\n  ],\n  # ...\n```\n\n```elixir\ndefmodule MultiProviderAuth do\n  @spec request(atom()) :: {:ok, map()} | {:error, term()}\n  def request(provider) do\n    config = config!(provider)\n\n    config[:strategy].authorize_url()\n  end\n\n  @spec callback(atom(), map(), map()) :: {:ok, map()} | {:error, term()}\n  def callback(provider, params, session_params) do\n    config = config!(provider)\n\n    config\n    |> Keyword.put(:session_params, session_params)\n    |> config[:strategy].callback(params)\n  end\n\n  defp config!(provider) do\n    config =\n      Application.get_env(:my_app, :strategies)[provider] ||\n        raise \"No provider configuration for #{provider}\"\n    \n    Keyword.put(config, :redirect_uri, \"http://localhost:4000/oauth/#{provider}/callback\")\n  end\nend\n```","title":"Multi-provider example - Assent","ref":"README.html#multi-provider-example"},{"type":"extras","doc":"You can create custom strategies. Here's an example of an OAuth 2.0 implementation using `Assent.Strategy.OAuth2.Base`:\n\n```elixir\ndefmodule TestProvider do\n  use Assent.Strategy.OAuth2.Base\n\n  @impl true\n  def default_config(_config) do\n    [\n      # `:base_url` will be used for any paths below\n      base_url: \"http://localhost:4000/api/v1\",\n       # Definining an absolute URI overrides the `:base_url`\n      authorize_url: \"http://localhost:4000/oauth/authorize\",\n      token_url: \"/oauth/access_token\",\n      user_url: \"/user\",\n      authorization_params: [scope: \"email profile\"],\n      auth_method: :client_secret_post\n    ]\n  end\n\n  @impl true\n  def normalize(_config, user) do\n    {:ok,\n      # Conformed to https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1\n      %{\n        \"sub\"      => user[\"sub\"],\n        \"name\"     => user[\"name\"],\n        \"nickname\" => user[\"username\"],\n        \"email\"    => user[\"email\"]\n      # },\n      # # Provider specific data not part of the standard claims spec\n      # %{\n      #   \"http://localhost:4000/bio\" => user[\"bio\"]\n      }\n    }\n  end\nend\n```\n\nThe normalized user map should conform to the [OpenID Connect Core 1.0 Standard Claims spec](https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1), and should return either `{:ok, userinfo_claims}` or `{:ok, userinfo_claims, additional}`. Any keys defined in the userinfo claims that aren't part of the specs will not be included in the user map. Instead, they should be set in the additional data that will then be merged on top of the userinfo claims excluding any keys that have already been set.\n\nYou can use any of the `Assent.Strategy.OAuth2.Base`, `Assent.Strategy.OAuth.Base`, and `Assent.Strategy.OIDC.Base` macros to set up the strategy.\n\nIf you need more control over the strategy than what the macros give you, you can implement your provider using the `Assent.Strategy` behaviour:\n\n```elixir\ndefmodule TestProvider do\n  @behaviour Assent.Strategy\n\n  @spec authorize_url(Keyword.t()) :: {:ok, %{url: binary()}} | {:error, term()}\n  def authorize_url(config) do\n    # Generate authorization url\n  end\n\n  @spec callback(Keyword.t(), map()) :: {:ok, %{user: map(), token: map()}} | {:error, term()}\n  def callback(config, params) do\n    # Handle callback response\n  end\nend\n```","title":"Custom provider - Assent","ref":"README.html#custom-provider"},{"type":"extras","doc":"Assent supports [`Req`](https://github.com/wojtekmach/req), [`Finch`](https://github.com/sneako/finch), and [`:httpc`](https://www.erlang.org/doc/man/httpc.html) out of the box. The `Req` HTTP client adapter will be used by default if enabled, otherwise Erlang's `:httpc` adapter will be included.\n\nYou can explicitly set the HTTP client adapter in the configuration:\n\n```elixir\nconfig = [\n  client_id: \"REPLACE_WITH_CLIENT_ID\",\n  client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n  http_adapter: Assent.HTTPAdapter.Httpc\n]\n```\n\nOr globally in the config:\n\n```elixir\nconfig :assent, http_adapter: Assent.HTTPAdapter.Httpc\n```\n\n### `Req`\n\nReq doesn't require any additional configuration and will work out of the box:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:req, \"~> 0.4\"}\n  ]\nend\n```\n\n### `:httpc`\n\nIf `Req` is not available, Erlangs built-in `:httpc` is used for requests. SSL verification is automatically enabled when `:certifi` and `:ssl_verify_fun` packages are available. `:httpc` only supports HTTP/1.1.\n\n```elixir\ndefp deps do\n  [\n    # ...\n    # Required for SSL validation if using the `:httpc` adapter\n    {:certifi, \"~> 2.4\"},\n    {:ssl_verify_fun, \"~> 1.1\"}\n  ]\nend\n```\n\nYou must include `:inets` to `:extra_applications` to include `:httpc` in your release.","title":"HTTP Client - Assent","ref":"README.html#http-client"},{"type":"extras","doc":"Finch will require a supervisor in your application.\n\nUpdate `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:finch, \"~> 0.16\"}\n  ]\nend\n```\n\nEnsure you start the Finch supervisor in your application, and set `:http_adapter` in your provider configuration using your connection pool:\n\n```elixir\nconfig = [\n  client_id: \"REPLACE_WITH_CLIENT_ID\",\n  client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n  http_adapter: {Assent.HTTPAdapter.Finch, supervisor: MyFinch}\n]\n```","title":"Finch - Assent","ref":"README.html#finch"},{"type":"extras","doc":"By default the built-in `Assent.JWTAdapter.AssentJWT` is used for JWT parsing, but you can change it to any third-party library with a custom `Assent.JWTAdapter`. A [JOSE](https://github.com/potatosalad/erlang-jose) adapter `Assent.JWTAdapter.JOSE` is included.\n\nTo use JOSE, update `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:jose, \"~> 1.8\"}\n  ]\nend\n```\n\nAnd pass the `:jwt_adapter` with your provider configuration:\n\n```elixir\nconfig = [\n  client_id: \"REPLACE_WITH_CLIENT_ID\",\n  client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n  jwt_adapter: Assent.JWTAdapter.JOSE\n]\n```\n\nOr globally in the config:\n\n```elixir\nconfig :assent, jwt_adapter: AssAssent.JWTAdapter.JOSE\n```","title":"JWT Adapter - Assent","ref":"README.html#jwt-adapter"},{"type":"extras","doc":"(The MIT License)\n\nCopyright (c) 2019-present Dan Schultzer & the Contributors\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","title":"LICENSE - Assent","ref":"README.html#license"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"CHANGELOG.html"},{"type":"extras","doc":"* Default to using `JSON` instead of `Jason` for JSON parsing on Elixir 1.18\n* `Assent.Strategy.OAuth2` now supports `:state` config option\n* `Assent.Strategy.OAuth2` `:state` override in `:authorization_parms` has been deprecated\n* `Assent.Strategy.OIDC` now supports `none` authentication method\n* `Assent.Strategy.Bitbucket` added\n* `Assent.Strategy.Twitch` added\n* `Assent.Strategy.Telegram` added\n* `Assent.Strategy.Zitadel` added\n* `Assent.Strategy.Facebook.fetch_user/2` fixed bug with user not being decoded\n* `Assent.Strategy.OAuth2` now supports PKCE\n* `Assent.Strategy.OAuth2.Base.authorize_url/2` incomplete typespec fixed\n* `Assent.Strategy.decode_response/2` deprecated accepting result tuples and now accepts `Assent.HTTPAdapter.HTTPResponse` structs\n* `Assent.Strategy.request/5` deprecated in favor of `Assent.Strategy.http_request/5`\n* `Assent.Strategy.decode_response/2` deprecated in favor of `Assent.HTTPAdapter.decode_response/2`\n* `Assent.Config.get/3` deprecated in favor of `Keyword.get/3`\n* `Assent.Config.put/3` deprecated in favor of `Keyword.put/3`\n* `Assent.Config.merge/2` deprecated in favor of `Keyword.merge/2`\n* `Assent.Config.t()` type deprecated in favor of `Keyword.t()` type\n* `Assent.Config.fetch/2` deprecated in favor of `Assent.fetch_config/2`","title":"v0.2.11 (2024-12-29) - Changelog","ref":"CHANGELOG.html#v0-2-11-2024-12-29"},{"type":"extras","doc":"Requires Elixir 1.13+\n\n- Fixed bug with trailing slash in `:base_url` not being ommitted when concatenating with relative path","title":"v0.2.10 (2024-04-11) - Changelog","ref":"CHANGELOG.html#v0-2-10-2024-04-11"},{"type":"extras","doc":"- Fixed bug where `Req` was not used by default if included in project\n- `Assent.Strategy.Httpc.request/5` now sets content length header","title":"v0.2.9 (2023-11-22) - Changelog","ref":"CHANGELOG.html#v0-2-9-2023-11-22"},{"type":"extras","doc":"`Req` will be used by default if available in your project, otherwise `:httpc` will be used.\n\n- `Req` HTTP adapter added\n- `Req` supported by default as HTTP client\n- Global application config support for HTTP and JWT adapters\n- More expressive errors now including the whole HTTP response where applicable\n- Deprecated `:site` config in favor of `:base_url` config","title":"v0.2.8 (2023-11-19) - Changelog","ref":"CHANGELOG.html#v0-2-8-2023-11-19"},{"type":"extras","doc":"* `Assent.Strategy.Strava` added","title":"v0.2.7 (2023-09-12) - Changelog","ref":"CHANGELOG.html#v0-2-7-2023-09-12"},{"type":"extras","doc":"* Added `Assent.HTTPAdapter.Finch`\n* Deprecated `Assent.HTTPAdapter.Mint`","title":"v0.2.6 (2023-08-26) - Changelog","ref":"CHANGELOG.html#v0-2-6-2023-08-26"},{"type":"extras","doc":"* `Assent.Strategy.Spotify` added","title":"v0.2.5 (2023-08-21) - Changelog","ref":"CHANGELOG.html#v0-2-5-2023-08-21"},{"type":"extras","doc":"* Fixed bug in `Assent.JWTAdapter.AssentJWT` where `verified?` could be a `{:error, term()}` tuple rather than boolean\n* Improved message on private key file load error","title":"v0.2.4 (2023-08-20) - Changelog","ref":"CHANGELOG.html#v0-2-4-2023-08-20"},{"type":"extras","doc":"* Removed `:castore` version requirement\n* `Assent.Strategy.Httpc.request/5` raises error when SSL certificate can't be validated","title":"v0.2.3 (2023-03-23) - Changelog","ref":"CHANGELOG.html#v0-2-3-2023-03-23"},{"type":"extras","doc":"* Fixed bug to handle 201 success response\n* `Assent.Strategy.OIDC` now has support for multiple audiences\n* `Assent.Strategy.OIDC` now permits any auth method if no `token_endpoint_auth_methods_supported` specified\n* `Assent.Strategy.Linkedin` added","title":"v0.2.2 (2023-02-27) - Changelog","ref":"CHANGELOG.html#v0-2-2-2023-02-27"},{"type":"extras","doc":"* Default to using `Jason` instead of `Poison` for JSON parsing\n* Fixed `Bitwise` warning when running on Elixir 1.14","title":"v0.2.1 (2022-09-15) - Changelog","ref":"CHANGELOG.html#v0-2-1-2022-09-15"},{"type":"extras","doc":"**This release consists of breaking changes.**\n\nIn previous `Assent.Strategy.Slack` strategy, the `sub` user id field consisted of `{SUB}-{TEAM}`. Slack has migrated to OpenID Connect, and the response has been conformed to OIDC. The `sub` will now only consists of the `sub` id, and not include team id. To succesfullly migrate to this release all slack identity records storing the `sub` user id field has to be updated.\n\nIf you wish to continue using the previous `sub` user id a custom OIDC strategy can be used instead:\n\n```elixir\ndefmodule Slack do\n  use Assent.Strategy.OIDC.Base\n\n  alias Assent.Strategy.Slack\n\n  defdelegate default_config(config), to: Slack\n\n  def normalize(config, user) do\n    user = Map.put(user, \"sub\", \"#{user[\"https://slack.com/user_id\"]}-#{user[\"https://slack.com/team_id\"]}\")\n\n    Slack.normalize(config, user)\n  end\nend\n```\n\n* `Assent.Strategy.OIDC.fetch_user/2` now removes the ID token specific keys from the user claims instead of normalizing\n* `Assent.Strategy.OIDC.Base` now adds `normalize/2` to the macro that will include the full user claims in the user params\n* `Assent.Strategy.Slack` now uses OpenID connect instead of legacy OAuth 2.0, please note that the `sub` value may have changed","title":"v0.2.0 (2022-03-01) - Changelog","ref":"CHANGELOG.html#v0-2-0-2022-03-01"},{"type":"extras","doc":"* `Assent.Strategy.OIDC` bug fixed so it handles unreachable urls correctly","title":"v0.1.28 (2021-09-30) - Changelog","ref":"CHANGELOG.html#v0-1-28-2021-09-30"},{"type":"extras","doc":"* `Assent.Strategy.OIDC` bug fixed for `normalize/2` macro callback","title":"v0.1.27 (2021-08-21) - Changelog","ref":"CHANGELOG.html#v0-1-27-2021-08-21"},{"type":"extras","doc":"* `Assent.constant_time_compare/2` no longer outputs a deprecation warning for OTP 24","title":"v0.1.26 (2021-05-27) - Changelog","ref":"CHANGELOG.html#v0-1-26-2021-05-27"},{"type":"extras","doc":"* `Assent.Strategy.Apple` has been fixed to handle the JSON encoded user in callback params","title":"v0.1.25 (2021-04-09) - Changelog","ref":"CHANGELOG.html#v0-1-25-2021-04-09"},{"type":"extras","doc":"* `Assent.Strategy.OIDC.Base.authorize_url/2` now has correct type specs","title":"v0.1.24 (2021-03-22) - Changelog","ref":"CHANGELOG.html#v0-1-24-2021-03-22"},{"type":"extras","doc":"Updated to support OTP 24 and no longer support OTP < 22.1\n\n* `Assent.Strategy.OIDC` now handles missing `id_token` in token params","title":"v0.1.23 (2021-03-01) - Changelog","ref":"CHANGELOG.html#v0-1-23-2021-03-01"},{"type":"extras","doc":"* `Assent.Strategy.OAuth2.fetch_user/4` now accepts headers in arguments\n* `Assent.Strategy.AzureAD` bug fixed so it now uses the `RS256` alg","title":"v0.1.22 (2021-01-08) - Changelog","ref":"CHANGELOG.html#v0-1-22-2021-01-08"},{"type":"extras","doc":"* `Assent.Strategy.OAuth` now handles missing params in callback phase\n* `Assent.Strategy.Twitter` now handles access denied callback","title":"v0.1.21 (2020-12-29) - Changelog","ref":"CHANGELOG.html#v0-1-21-2020-12-29"},{"type":"extras","doc":"* `Assent.Strategy.Stripe` added\n* `Assent.Strategy.to_url/3` now handles nested query params\n* `Assent.Strategy.OAuth2` no longer removes padding for base64 encoding authorization header\n* `Assent.Strategy.OIDC.validate_id_token/2` now supports dynamic OpenID configuration\n* `Assent.Strategy.OIDC.fetch_userinfo/2` now supports dynamic OpenID configuration","title":"v0.1.20 (2020-12-10) - Changelog","ref":"CHANGELOG.html#v0-1-20-2020-12-10"},{"type":"extras","doc":"* Updated docs to detail `:inets` compilation\n* `Assent.OAuth2.authorize_url/1` now returns the state, if defined, from `authorization_params`","title":"v0.1.19 (2020-11-25) - Changelog","ref":"CHANGELOG.html#v0-1-19-2020-11-25"},{"type":"extras","doc":"* Removed `oauther` dependency","title":"v0.1.18 (2020-11-08) - Changelog","ref":"CHANGELOG.html#v0-1-18-2020-11-08"},{"type":"extras","doc":"* Relax `mint` requirement","title":"v0.1.17 (2020-11-05) - Changelog","ref":"CHANGELOG.html#v0-1-17-2020-11-05"},{"type":"extras","doc":"**Warning:** This release has breaking changes.\n\nAll `get_user/2` functions has been renamed to `fetch_user/2` as they return `{:ok, res}`/`{:error, res}` tuples.\n\n* `Assent.OAuth.get/4` removed in favor of `Assent.OAuth.request/6`\n* `Assent.OAuth2.get_access_token/3` renamed to `Assent.OAuth2.grant_access_token/3`\n* `Assent.OAuth2.get/4` removed in favor of `Assent.OAuth2.request/6`","title":"v0.1.16 (2020-10-21) - Changelog","ref":"CHANGELOG.html#v0-1-16-2020-10-21"},{"type":"extras","doc":"* `Assent.Strategy.OIDC.validate_id_token/2` has a bug fixed where `alg` was not validated correctly\n* `Assent.Strategy.OIDC` now has an `:id_token_signed_response_alg` configuration option\n* `Assent.Strategy.LINE` added","title":"v0.1.15 (2020-10-18) - Changelog","ref":"CHANGELOG.html#v0-1-15-2020-10-18"},{"type":"extras","doc":"* `Assent.Strategy.OAuth2.get_access_token/3` added\n* `Assent.Strategy.OAuth2.refresh_access_token/3` added\n* `Assent.Strategy.OAuth2.authorization_headers/2` is no long a public function\n* `Assent.Strategy.Apple` updated to handle `name` scope","title":"v0.1.14 (2020-10-11) - Changelog","ref":"CHANGELOG.html#v0-1-14-2020-10-11"},{"type":"extras","doc":"* `Assent.Strategy.DigitalOcean` added","title":"v0.1.13 (2020-07-14) - Changelog","ref":"CHANGELOG.html#v0-1-13-2020-07-14"},{"type":"extras","doc":"* `Assent.Strategy.OAuth2.authorization_headers/2` now capitalizes the token type in the authorization header\n* `Assent.Strategy.OIDC.callback/2` now calls the strategy `get_user/2` method before any ID token validation\n* `Assent.Strategy.OIDC.validate_id_token/2` added\n* `Assent.Strategy.OIDC.fetch_userinfo/2` added\n* `Assent.Strategy.OIDC` no longer fetches the userinfo by default instead using the claims in the ID Token","title":"v0.1.12 (2020-05-24) - Changelog","ref":"CHANGELOG.html#v0-1-12-2020-05-24"},{"type":"extras","doc":"* `Assent.Strategy.OAuth2.callback/2` now requires `:session_params` to be set in the config\n* `Assent.Strategy.OIDC.callback/2` now requires `:session_params` to be set in the config\n* `Assent.Strategy.OAuth2` now uses constant time comparison for state\n* `Assent.Strategy.OIDC` now uses constant time comparison for nonce\n* `Assent.Strategy.Httpc.request/5` bug fixed for certificates that has wildcard domain with SAN extension\n* `Assent.Strategy.Mint.request/5` bug fixed for certificates that has wildcard domain with SAN extension","title":"v0.1.11 (2020-05-16) - Changelog","ref":"CHANGELOG.html#v0-1-11-2020-05-16"},{"type":"extras","doc":"Now requires Mint 1.0.0 or higher.\n\n* `Assent.Strategy.Instagram` now accepts `:user_url_request_fields` config option and passes `fields` params to the `/me` point","title":"v0.1.10 (2020-04-23) - Changelog","ref":"CHANGELOG.html#v0-1-10-2020-04-23"},{"type":"extras","doc":"Now requires Elixir 1.7 or higher.\n\n* `Assent.Strategy.Instagram` now uses the Instagram Graph API\n* `Assent.Strategy.OIDC` bug fixed when no `:session_params` set in config","title":"v0.1.9 (2020-04-23) - Changelog","ref":"CHANGELOG.html#v0-1-9-2020-04-23"},{"type":"extras","doc":"* `Assent.Strategy.Github` now provides `email_verified` value\n* `Assent.Strategy.Gitlab` now provides `email_verified` value\n* `Assent.Strategy.Google` fixed to provide correct `email_verified` value\n* `Assent.Strategy.Twitter` now provides `email_verified` value","title":"v0.1.8 (2020-02-15) - Changelog","ref":"CHANGELOG.html#v0-1-8-2020-02-15"},{"type":"extras","doc":"* Fix `Assent.HTTPAdapter.Mint` where `:unknown` responses where not handled correctly","title":"v0.1.7 (2020-02-10) - Changelog","ref":"CHANGELOG.html#v0-1-7-2020-02-10"},{"type":"extras","doc":"* `Assent.Strategy.AzureAD` now uses auth code flow instead of hybrid flow","title":"v0.1.6 (2020-01-30) - Changelog","ref":"CHANGELOG.html#v0-1-6-2020-01-30"},{"type":"extras","doc":"* Removed unused `:resource` param in `Assent.Strategy.AzureAD`\n* Added \"email profile\" to scope in `Assent.Strategy.AzureAD`\n* Use `response_mode=form_post` for `Assent.Strategy.AzureAD`\n* Updated `Assent.Strategy.OAuth2` to handle access token request correctly when `:auth_method` is `nil` per RFC specs\n* Changed `Assent.Strategy.Apple` to use OIDC strategy and verify the JWT\n* Changed `Assent.Strategy.OIDC` to update token with the expanded JWT as the `id_token`\n* Fixed bug in `Assent.HTTPAdapter.Mint` with query params not being included in request","title":"v0.1.5 (2020-01-13) - Changelog","ref":"CHANGELOG.html#v0-1-5-2020-01-13"},{"type":"extras","doc":"* Support mint up to `v1.0.x`\n* Fixed bug in `Assent.JWTAdapter.JOSE` where `nil` secret value raised an exception\n* Fixed bug in `Assent.JWTAdapter.AssentJWT` where ECDSA algorithms didn't generate or verify valid signatures","title":"v0.1.4 (2019-11-09) - Changelog","ref":"CHANGELOG.html#v0-1-4-2019-11-09"},{"type":"extras","doc":"* Fixed bug in `Assent.Strategy.Github` where multiple emails for account resulted in the verified primary e-mail not being returned","title":"v0.1.3 (2019-10-27) - Changelog","ref":"CHANGELOG.html#v0-1-3-2019-10-27"},{"type":"extras","doc":"* Require `:redirect_uri` is set in the config of `Assent.Strategy.OAuth2.callback/3` instead of as `redirect_uri` in the params","title":"v0.1.2 (2019-10-08) - Changelog","ref":"CHANGELOG.html#v0-1-2-2019-10-08"},{"type":"extras","doc":"* Relax mint requirement\n* Fix bug in `Assent.HTTPAdapter.Mint` where HTTP/2 responses wasn't parsed correctly","title":"v0.1.1 (2019-10-07) - Changelog","ref":"CHANGELOG.html#v0-1-1-2019-10-07"},{"type":"extras","doc":"* Initial release","title":"v0.1.0 (2019-10-06) - Changelog","ref":"CHANGELOG.html#v0-1-0-2019-10-06"}],"content_type":"text/markdown","proglang":"elixir","producer":{"name":"ex_doc","version":"0.36.1"}}